#include <Client/CreditsWindow.hpp>

int line_index = 0;
JUI::TextRect* line_item(const std::string& content, int size, const Color4& color = Colors::White) {
    auto* item = new JUI::TextRect();
    item->Font(JGL::Fonts::Jupiteroid);
    item->Size({0,4+size,1.f,0.f});
    item->TextSize(size);
    item->Content(content);
    item->AlignCenterHorizontally();
    item->AlignTop();
    item->BGColor({0,0,0,0});
    item->TextColor(color);
    item->BorderWidth(0);
    item->LayoutOrder(line_index++);
    return item;
}

JUI::Window *CaveGame::Client::CreateCreditsWindowWidget(JUI::Widget *parent) {

    auto* credits_window = new JUI::Window(parent);
    credits_window->SetTitleFont(JGL::Fonts::Jupiteroid);
    credits_window->Title("Credits");
    //credits_window->MinSize({250, 450});
    //credits_window->Size({300, 450, 0, 0});
    credits_window->Visible(false);
    credits_window->ViewportInstance()->BGColor({48, 48, 48});

    auto* listing = new JUI::VerticalListLayout(credits_window->ViewportInstance());
    listing->LayoutOrder(JUI::LayoutOrder::V::BOTTOM);
    //listing->Margin(4_px);
    //listing->Padding(5_px);

    int min_height = 0;
    for (auto line : Credits)
    {
        listing->Add(line_item(line.content, line.text_size, line.text_color));
        min_height += line.text_size + 6;
    }

    credits_window->MinSize({300, (float)min_height});
    credits_window->Size(UDim2::FromPixels(300, min_height));
    credits_window->SetResizable(false);

    /*
    line_item("CaveGame", 40, listing);
    line_item("A Redacted Software Product", 16, listing);
    line_item("Josh O'Leary", 24, listing);
    line_item("Design, Programming & Art", 16, listing);
    line_item("William Redacted", 24, listing);
    line_item("Redacted3D Game Technologies", 16, listing);
    line_item("Ash Tray", 24, listing);
    line_item("Art & Design", 16, listing);
    line_item("Evan Walter & Logan Caughlin", 24, listing);
    line_item("Music", 16, listing);
    line_item("Maxine Hayes", 24, listing);
    line_item("Systems Administration", 16, listing);
    line_item("Karl Darling", 24, listing);
    line_item("Financial Advisor", 16, listing);*/

    //credits_window->Size({300, Math::Max(400, min_height), 0, 0});

    return credits_window;
}
