#pragma once

namespace CaveGame::Core
{
    /// A biome defines a region in the world with distinct characteristics, such as:
    // Background textures / effects
    // Terrain Generation
    // Entity Spawns
    // Generated Structures / Dungeons
    // Music / Ambiance
    // Weather
    // Physics Modifiers
    // Multiple biomes may be occur in a place at a time.
    class Biome { };

#define BIOME static const Biome

    /// List of biomes.
    namespace Biomes {

        /// The world is split into horizontal slices, each controlled by a higher-level "Elevation Biome"
#pragma region Elevation Biomes
        BIOME Space;        // -1000 < Y
        BIOME Surface;      // 1000 < Y <= -1000
        BIOME Subsurface;   // 2000 < Y <= 1000
        BIOME Underground;  // 10000 < T <= 2000
        BIOME Deep;         // 50000 < Y <= 10000
        BIOME Mantle;       // Y <= 50000
#pragma endregion

#pragma region Environmental Biomes
        BIOME Grassland;
        BIOME Forest;
        BIOME DenseForest;
        BIOME Tundra;
        BIOME Taiga;
        BIOME RedwoodForest;
        BIOME WinterWonderland;
        BIOME AshForest;
        BIOME Desert;
        BIOME Badlands;
        BIOME BloodForest;
        BIOME BlackForest;
        BIOME Mountains;
        BIOME SuperMountains;
        BIOME Marsh;
        BIOME Lake;
        BIOME ContaminationZome;
        BIOME Jungle;
        BIOME FungusForest;
#pragma endregion

    }


}