#pragma once

#include <J3ML/LinearAlgebra.hpp>
#include <map>
#include <Core/Itemstack.hpp>
#include "Core/v2i_hash.hpp"

namespace CaveGame::Core
{
    enum RestrictListMode
    {
        ALLOWLIST,
        DENYLIST
    };

    class Container {
    public:

        RestrictListMode whitelist_mode;

        Container(int rows, int columns);

        ItemStack &At(const Vector2i &cell);

        /// Returns how much of the stack would be left-over if inserted into this container.
        /// Storing onto existing non-full item stacks of the same type will occur.
        int CanFitItemStack(const ItemStack &item)
        {
           return 0;
        }

        bool IsSlotEmpty(const Vector2i& cell)
        {
            return true;
        }

        int Insert(const ItemStack &item)
        {
            return 0;
        }

    protected:
    private:
        std::unordered_map<Vector2i, ItemStack> contents;
    };
}
