#include <Core/Explosion.hpp>

namespace CaveGame::Core {

    void Explosion::SetFrame(const AABB2D& frame_quad)
    {
        this->quad = frame_quad;
    }

    AABB2D Explosion::CurrentFrame() const { return quad;}


    bool Explosion::HasDetonated() const { return detonated;}

    void Explosion::Update(float elapsed) {

        //Entity::Update(elapsed);

        if (fuse > 0.f)
            fuse -= elapsed;

        if (fuse <= 0.f && !HasDetonated())
            Detonate();


        if (HasDetonated())
            anim_timer += elapsed;

        if (HasDetonated()) {
            if (anim_timer < 1.25f) {
                if (anim_timer > (4.f / 5.f)) {
                    SetFrame(SP_EXPLOSION4);
                    //JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION4.minPoint, SP_EXPLOSION4.maxPoint, rotation, {0.5f,0.5f}, {draw_radius/16.f, draw_radius/16.f});
                } else if (anim_timer > (3.f / 5.f)) {
                    SetFrame(SP_EXPLOSION3);
                    //JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION3.minPoint, SP_EXPLOSION3.maxPoint, rotation, {0.5f, 0.5f}, {draw_radius/16.f, draw_radius/16.f});
                } else if (anim_timer > (2.f / 5.f)) {
                    SetFrame(SP_EXPLOSION2);
                    //JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION2.minPoint, SP_EXPLOSION2.maxPoint, rotation, {0.5f, 0.5f}, {draw_radius/16.f, draw_radius/16.f});
                } else if (anim_timer > (1.f / 5.f)) {
                    SetFrame(SP_EXPLOSION1);
                    //JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION1.minPoint, SP_EXPLOSION1.maxPoint, rotation, {0.5f, 0.5f}, {draw_radius/16.f, draw_radius/16.f});
                } else {
                    SetFrame(SP_EXPLOSION0);
                    //JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION0.minPoint, SP_EXPLOSION0.maxPoint, rotation, {0.5f, 0.5f}, {draw_radius/16.f, draw_radius/16.f});
                }
            }

        }

    }
}