#include <Core/Macros.hpp>
#include <fstream>

std::vector<std::string> string_split(const std::string &s, char delim) {
    std::vector<std::string> result;
    std::stringstream ss (s);
    std::string item;

    while(getline(ss, item, delim)) {
        result.push_back(item);
    }
    return result;
}

std::string string_build(const std::vector<std::string> &list, const std::string& delim) {

    std::stringstream s;
    for (auto it = list.begin(); it != list.end(); it++)
    {
        if (it != list.end()-1)
            s << *it << delim;
        else
            s << *it;
    }
    return s.str();

    //return std::accumulate(std::begin(list), std::end(list), list[0],
    //                           [&delim](std::string &ss, std::string &s)
    //{
    //                               return ss.empty() ? s : ss + delim + s;
    //                           });
}

std::string read_file(const std::filesystem::path& file_path) {
    std::ifstream file(file_path, std::ios::binary | std::ios::ate);
    if (!file)
        throw std::runtime_error("We couldn't find the file: " + file_path.string());

    std::streamsize file_size;
    file.seekg(0, std::ios::end);
    file_size = file.tellg();
    file.seekg(0, std::ios::beg);

    std::string file_content(file_size, '\0');
    file.read(&file_content[0], file_size);
    file.close();

    return file_content;
}
